Hash :
49c543a6
Author :
Date :
2022-03-31T20:41:38
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508
#!/bin/sh
#
# Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
. ./common.sh
test_integrate_basic() {
local testroot=`test_init integrate_basic`
(cd $testroot/repo && git checkout -q -b newbranch)
echo "modified delta on branch" > $testroot/repo/gamma/delta
git_commit $testroot/repo -m "committing to delta on newbranch"
echo "modified alpha on branch" > $testroot/repo/alpha
(cd $testroot/repo && git rm -q beta)
echo "new file on branch" > $testroot/repo/epsilon/new
(cd $testroot/repo && git add epsilon/new)
git_commit $testroot/repo -m "committing more changes on newbranch"
local orig_commit1=`git_show_parent_commit $testroot/repo`
local orig_commit2=`git_show_head $testroot/repo`
(cd $testroot/repo && git checkout -q master)
echo "modified zeta on master" > $testroot/repo/epsilon/zeta
git_commit $testroot/repo -m "committing to zeta on master"
local master_commit=`git_show_head $testroot/repo`
got checkout $testroot/repo $testroot/wt > /dev/null
ret=$?
if [ $ret -ne 0 ]; then
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got rebase newbranch > /dev/null)
ret=$?
if [ $ret -ne 0 ]; then
echo "got rebase failed unexpectedly"
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/repo && git checkout -q newbranch)
local new_commit1=`git_show_parent_commit $testroot/repo`
local new_commit2=`git_show_head $testroot/repo`
(cd $testroot/wt && got update -b master > /dev/null)
ret=$?
if [ $ret -ne 0 ]; then
echo "got update failed unexpectedly"
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got integrate newbranch > $testroot/stdout)
echo "U alpha" > $testroot/stdout.expected
echo "D beta" >> $testroot/stdout.expected
echo "A epsilon/new" >> $testroot/stdout.expected
echo "U gamma/delta" >> $testroot/stdout.expected
echo "Integrated refs/heads/newbranch into refs/heads/master" \
>> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
echo "modified delta on branch" > $testroot/content.expected
cat $testroot/wt/gamma/delta > $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
echo "modified alpha on branch" > $testroot/content.expected
cat $testroot/wt/alpha > $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
if [ -e $testroot/wt/beta ]; then
echo "removed file beta still exists on disk" >&2
test_done "$testroot" "1"
return 1
fi
echo "new file on branch" > $testroot/content.expected
cat $testroot/wt/epsilon/new > $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/content.expected $testroot/content
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got status > $testroot/stdout)
echo -n > $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got log -l3 | grep ^commit > $testroot/stdout)
echo "commit $new_commit2 (master, newbranch)" \
> $testroot/stdout.expected
echo "commit $new_commit1" >> $testroot/stdout.expected
echo "commit $master_commit" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got update > $testroot/stdout)
echo "Already up-to-date" > $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
fi
test_done "$testroot" "$ret"
}
test_integrate_requires_rebase_first() {
local testroot=`test_init integrate_requires_rebase_first`
local init_commit=`git_show_head $testroot/repo`
(cd $testroot/repo && git checkout -q -b newbranch)
echo "modified delta on branch" > $testroot/repo/gamma/delta
git_commit $testroot/repo -m "committing to delta on newbranch"
echo "modified alpha on branch" > $testroot/repo/alpha
(cd $testroot/repo && git rm -q beta)
echo "new file on branch" > $testroot/repo/epsilon/new
(cd $testroot/repo && git add epsilon/new)
git_commit $testroot/repo -m "committing more changes on newbranch"
local orig_commit1=`git_show_parent_commit $testroot/repo`
local orig_commit2=`git_show_head $testroot/repo`
(cd $testroot/repo && git checkout -q master)
echo "modified zeta on master" > $testroot/repo/epsilon/zeta
git_commit $testroot/repo -m "committing to zeta on master"
local master_commit=`git_show_head $testroot/repo`
(cd $testroot/repo && git checkout -q newbranch)
local new_commit1=`git_show_parent_commit $testroot/repo`
local new_commit2=`git_show_head $testroot/repo`
got checkout -b master $testroot/repo $testroot/wt > /dev/null
ret=$?
if [ $ret -ne 0 ]; then
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got integrate newbranch \
> $testroot/stdout 2> $testroot/stderr)
ret=$?
if [ $ret -eq 0 ]; then
echo "got integrate succeeded unexpectedly"
test_done "$testroot" "$ret"
return 1
fi
echo -n > $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
echo "got: specified branch must be rebased first" \
> $testroot/stderr.expected
cmp -s $testroot/stderr.expected $testroot/stderr
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stderr.expected $testroot/stderr
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/repo && got log -c master | \
grep ^commit > $testroot/stdout)
echo "commit $master_commit (master)" > $testroot/stdout.expected
echo "commit $init_commit" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/repo && got log -c newbranch | \
grep ^commit > $testroot/stdout)
echo "commit $new_commit2 (newbranch)" \
> $testroot/stdout.expected
echo "commit $new_commit1" >> $testroot/stdout.expected
echo "commit $init_commit" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/repo && got branch -l > $testroot/stdout)
ret=$?
if [ $ret -ne 0 ]; then
echo "got rebase failed unexpectedly"
test_done "$testroot" "$ret"
return 1
fi
echo " master: $master_commit" > $testroot/stdout.expected
echo " newbranch: $new_commit2" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
fi
test_done "$testroot" "$ret"
}
test_integrate_path_prefix() {
local testroot=`test_init integrate_path_prefix`
(cd $testroot/repo && git checkout -q -b newbranch)
echo "modified delta on branch" > $testroot/repo/gamma/delta
git_commit $testroot/repo -m "committing to delta on newbranch"
echo "modified alpha on branch" > $testroot/repo/alpha
(cd $testroot/repo && git rm -q beta)
echo "new file on branch" > $testroot/repo/epsilon/new
(cd $testroot/repo && git add epsilon/new)
git_commit $testroot/repo -m "committing more changes on newbranch"
local orig_commit1=`git_show_parent_commit $testroot/repo`
local orig_commit2=`git_show_head $testroot/repo`
(cd $testroot/repo && git checkout -q master)
echo "modified zeta on master" > $testroot/repo/epsilon/zeta
git_commit $testroot/repo -m "committing to zeta on master"
local master_commit=`git_show_head $testroot/repo`
got checkout $testroot/repo $testroot/wt > /dev/null
ret=$?
if [ $ret -ne 0 ]; then
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got rebase newbranch > /dev/null)
ret=$?
if [ $ret -ne 0 ]; then
echo "got rebase failed unexpectedly"
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/repo && git checkout -q newbranch)
local new_commit1=`git_show_parent_commit $testroot/repo`
local new_commit2=`git_show_head $testroot/repo`
rm -r $testroot/wt
got checkout -b master -p epsilon $testroot/repo $testroot/wt \
> /dev/null
ret=$?
if [ $ret -ne 0 ]; then
echo "got checkout failed unexpectedly"
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got integrate newbranch > $testroot/stdout)
echo "A new" > $testroot/stdout.expected
echo "Integrated refs/heads/newbranch into refs/heads/master" \
>> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
fi
test_done "$testroot" "$ret"
}
test_integrate_backwards_in_time() {
local testroot=`test_init integrate_backwards_in_time`
(cd $testroot/repo && git checkout -q -b newbranch)
echo "modified delta on branch" > $testroot/repo/gamma/delta
git_commit $testroot/repo -m "committing to delta on newbranch"
echo "modified alpha on branch" > $testroot/repo/alpha
(cd $testroot/repo && git rm -q beta)
echo "new file on branch" > $testroot/repo/epsilon/new
(cd $testroot/repo && git add epsilon/new)
git_commit $testroot/repo -m "committing more changes on newbranch"
local orig_commit1=`git_show_parent_commit $testroot/repo`
local orig_commit2=`git_show_head $testroot/repo`
(cd $testroot/repo && git checkout -q master)
echo "modified zeta on master" > $testroot/repo/epsilon/zeta
git_commit $testroot/repo -m "committing to zeta on master"
local master_commit=`git_show_head $testroot/repo`
got checkout $testroot/repo $testroot/wt > /dev/null
ret=$?
if [ $ret -ne 0 ]; then
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got rebase newbranch > /dev/null)
ret=$?
if [ $ret -ne 0 ]; then
echo "got rebase failed unexpectedly"
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/repo && git checkout -q newbranch)
local new_commit1=`git_show_parent_commit $testroot/repo`
local new_commit2=`git_show_head $testroot/repo`
# attempt to integrate master into newbranch (wrong way around)
(cd $testroot/wt && got update -b newbranch > /dev/null)
ret=$?
if [ $ret -ne 0 ]; then
echo "got update failed unexpectedly"
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got integrate master \
> $testroot/stdout 2> $testroot/stderr)
ret=$?
if [ $ret -eq 0 ]; then
echo "got integrate succeeded unexpectedly"
test_done "$testroot" "$ret"
return 1
fi
echo -n > $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
echo "got: specified branch must be rebased first" \
> $testroot/stderr.expected
cmp -s $testroot/stderr.expected $testroot/stderr
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stderr.expected $testroot/stderr
fi
test_done "$testroot" "$ret"
}
test_integrate_replace_symlink_with_file() {
local testroot=`test_init integrate_replace_symlink_with_file`
got checkout $testroot/repo $testroot/wt > /dev/null
ret=$?
if [ $ret -ne 0 ]; then
echo "checkout failed unexpectedly" >&2
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && ln -s alpha alpha.link)
(cd $testroot/wt && got add alpha alpha.link >/dev/null)
(cd $testroot/wt && got commit -m "add regular file and symlink" \
>/dev/null)
(cd $testroot/wt && got br replace_symlink_with_file >/dev/null)
(cd $testroot/wt && rm alpha.link >/dev/null)
(cd $testroot/wt && cp alpha alpha.link)
(cd $testroot/wt && got stage alpha.link >/dev/null)
(cd $testroot/wt && got commit -m "replace symlink" >/dev/null)
(cd $testroot/wt && got up -b master >/dev/null)
(cd $testroot/wt && got integrate replace_symlink_with_file \
> $testroot/stdout)
echo "U alpha.link" > $testroot/stdout.expected
echo -n "Integrated refs/heads/replace_symlink_with_file " \
>> $testroot/stdout.expected
echo "into refs/heads/master" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
if [ -h $testroot/wt/alpha.link ]; then
echo "alpha.link is still a symlink"
test_done "$testroot" "1"
return 1
fi
echo "alpha" > $testroot/content.expected
cat $testroot/wt/alpha.link > $testroot/content
cmp -s $testroot/content.expected $testroot/content
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/content.expected $testroot/content
fi
test_done "$testroot" "$ret"
}
test_integrate_replace_file_with_symlink() {
local testroot=`test_init integrate_replace_file_with_symlink`
got checkout $testroot/repo $testroot/wt > /dev/null
ret=$?
if [ $ret -ne 0 ]; then
echo "checkout failed unexpectedly" >&2
test_done "$testroot" "$ret"
return 1
fi
(cd $testroot/wt && got br replace_file_with_symlink >/dev/null)
(cd $testroot/wt && rm alpha)
(cd $testroot/wt && ln -s beta alpha)
(cd $testroot/wt && got commit -m "replace regular file with symlink" \
>/dev/null)
(cd $testroot/wt && got up -b master >/dev/null)
(cd $testroot/wt && got integrate replace_file_with_symlink \
> $testroot/stdout)
echo "U alpha" > $testroot/stdout.expected
echo -n "Integrated refs/heads/replace_file_with_symlink " \
>> $testroot/stdout.expected
echo "into refs/heads/master" >> $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
test_done "$testroot" "$ret"
return 1
fi
if ! [ -h $testroot/wt/alpha ]; then
echo "alpha is not a symlink"
test_done "$testroot" "1"
return 1
fi
readlink $testroot/wt/alpha > $testroot/stdout
echo "beta" > $testroot/stdout.expected
cmp -s $testroot/stdout.expected $testroot/stdout
ret=$?
if [ $ret -ne 0 ]; then
diff -u $testroot/stdout.expected $testroot/stdout
fi
test_done "$testroot" "$ret"
}
test_parseargs "$@"
run_test test_integrate_basic
run_test test_integrate_requires_rebase_first
run_test test_integrate_path_prefix
run_test test_integrate_backwards_in_time
run_test test_integrate_replace_symlink_with_file
run_test test_integrate_replace_file_with_symlink